routes/web.php
<?php

use App\Http\Controllers\HomeController;
use App\Http\Controllers\TiendaController;
use App\Http\Controllers\ProductoController;
use App\Http\Controllers\ProductotiendaController;
use Illuminate\Support\Facades\Route;

Route::controller(HomeController::class)->group(function () {
    Route::get('/', 'index')->name('index');
    Route::get('/index', 'index')->name('home.index');
});

Route::resource('tienda', TiendaController::class);
Route::resource('producto', ProductoController::class);
Route::resource('productoTienda', ProductotiendaController::class);

app/Models/Productotienda.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Support\Facades\Schema;

class Productotienda extends Model {
    use HasFactory;

    protected $table = 'producto_tiendas';
    protected $fillable = [
        'cantidad',
        'producto_id',
        'tienda_id',
    ];

    public function getFields() {
        return Schema::getColumnListing($this->table);
    }

    public static $labels = [
        'id' => 'ID Producto Tienda',
        'producto_id' => 'Producto ID',
        'tienda_id' => 'Tienda ID',
        'nombretienda' => 'Nombre Tienda',
        'nombreproducto' => 'Nombre Producto',
    ];

    public function tienda() : BelongsTo {
        return $this->belongsTo(Tienda::class);
    }

    public function producto() : BelongsTo {
        return $this->belongsTo(Producto::class);
    }

    /**
     * Recupera el valor del atributo nombreTienda del modelo tienda.
     *
     * @return string El valor del atributo nombreTienda.
    */
    public function getNombreTiendaAttribute(): string {
        return $this->tienda->nombre;
    }

    public function getNombreProductoAttribute(): string {
        return $this->producto->nombre;
    }

    public function getAttributeLabel($attribute) {
        return self::$labels[$attribute] ?? $attribute;
    }
}

app/Http/Controllers/ProductotiendaController.php
<?php

namespace App\Http\Controllers;

use App\Models\Productotienda;
use Illuminate\Http\Request;

class ProductotiendaController extends Controller {
    /**
     * Display a listing of the resource.
     */
    public function index() {
        $productoTiendas = Productotienda::paginate(15);

        //dd($productoTiendas[0]->nombreProducto);

        return view('productoTienda.index', compact('productoTiendas'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create() {
        return view('productoTienda.create');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request) {
        $request->validate([
            'cantidad' => 'required|numeric|max:1000',
            'id_producto' => 'required',
            'id_tienda' => 'required',
        ]);

        $productoTienda = Productotienda::create($request->all());
        
        return redirect()
            ->route('productoTienda.show', $productoTienda->id)
            ->with('mensaje', 'Producto de la tienda creado con éxito')
        ;
    }

    /**
     * Display the specified resource.
     */
    public function show(int $id) {
        $productoTienda = Productotienda::find($id);

        

        return view('productoTienda.show', compact('productoTienda'));
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(int $id) {
        $productoTienda = Productotienda::find($id);

        return view('productoTienda.edit', compact('productoTienda'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Productotienda $productoTienda) {
        $request->validate([
            'cantidad' => 'required|numeric|max:1000',
            'id_producto' => 'required',
            'id_tienda' => 'required',
        ]);

        $productoTienda->update($request->all());

        return redirect()
            ->route('productoTienda.show', $productoTienda->id)
            ->with('mensaje', 'Producto de la tienda actualizado con éxito');
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Productotienda $productoTienda) {
        $productoTienda->delete();
        
        return redirect()
            ->route('productoTienda.index')
            ->with('mensaje', 'Producto de la tienda borrado con éxito')
        ;
    }
}

resources/views/productoTienda/create.blade.php
@extends('layouts.main')

@section('titulo', 'Crear Clientes')

@section('cabecera')
    @parent
@endsection

@section('contenido')
    <x-formularios.formulario :errors="$errors" route="{{ route('productoTienda.store') }}">
        <x-formularios.input type="number" label="Cantidad" name="cantidad" :value="old('nombre')"/>
        <x-formularios.input type="number" label="Producto ID" name="producto" :value="old('producto')"/>
        <x-formularios.input type="number" label="Tienda ID" name="tienda" :value="old('tienda')"/>
    </x-formularios.formulario>
@endsection

resources/views/productoTienda/edit.blade.php
@extends('layouts.main')

@section('titulo', 'Editar Producto Tienda')

@section('cabecera')
    @parent
@endsection

@section('contenido')
    <ul class="nav nav-tabs mb-5">
        <li class="nav-item">
            <a class="nav-link" aria-current="page" href="{{ route('productoTienda.show', $productoTienda->id) }}">Producto  de la Tienda {{ $productoTienda->id }}</a>
        </li>

        <li class="nav-item">
            <a class="nav-link active disabled" aria-disabled="true" href="{{ route('productoTienda.edit', $productoTienda->id) }}">Editar Producto Tienda</a>
        </li>
        
        <li class="nav-item" style="margin-left: auto;">
            <a class="nav-link" aria-current="page" href="{{ route('productoTienda.show', $productoTienda->id) }}">Volver</a>
        </li>
    </ul>

    @if (session('mensaje'))
        <div class="card gradient-for-card-se mb-4">
            <div class="card-body text-center" style="background-color: #0e1321">
                <p class="card-text lead fs-4">{{ session('mensaje') }} </p>
            </div>
        </div>
    @endif
    
    @if ($errors->any())
        <div class="card gradient-for-card-se mb-4">
            <div class="card-body text-center" style="background-color: #0e1321">
                <h2 class="card-title font-italic">Error</h2>
                @foreach ($errors->all() as $error)
                    <p class="card-text lead fs-4"> {{ $error }} </p>
                @endforeach
            </div>
        </div>
    @endif

    <div class="row justify-content-center">
        <div class="col-lg-8 card">
            <div class="card-body">
                <h1 class="text-gradient-secondary text-center">Actualizar Producto de la Tienda</h1>

                @php
                    $composIncluidos = ['cantidad'];
                    $campos = collect($productoTienda->getAttributes())->only($composIncluidos)->keys();
                @endphp

                <form action="{{ route('productoTienda.update', $productoTienda) }}" class="card-body cardbody-color p-lg-5 needs-validation" novalidate method="POST">
                    @csrf
                    @method('PUT')

                    @foreach($campos as $campo)
                        <div class="input-group mb-3">
                            <div class="input-group has-validation">
                                <div class="form-floating">
                                    <input type="number" class="form-control" id="{{ $campo }}" name="{{ $campo }}" value="{{ old($campo, $productoTienda->$campo) }}" required>
                                    <label class="form-label" for="{{ $campo }}">{{ ucfirst($campo) }}</label>
                                    <div id="{{ $campo }}" class="invalid-feedback">
                                        Este campo es obligatorio.
                                    </div>
                                    @error($campo)
                                        <p style="color: #dc3545;"> {{ $message }} </p>
                                    @enderror
                                </div>
                            </div>
                        </div>
                    @endforeach
                    <div class="text-center">
                        <button type="submit" class="btn btn-secondary btn-lg">Actualizar</button>
                    </div>
                </form>
            </div>
        </div>
    </div>

    <script>
        document.addEventListener('submit', validacionFormulario);

        function validacionFormulario(e) {
            const formulario = e.target;

            if (!formulario.classList.contains('needs-validation')) {
                return;
            }

            // Si el formulario no es válido, previene el evento de envío y detiene la propagación
            if (!formulario.checkValidity()) {
                e.preventDefault();
                e.stopPropagation();
            }

            formulario.classList.add('was-validated');
        }
    </script>
@endsection

resources/views/productoTienda/index.blade.php
@extends('layouts.main')

@section('titulo', 'Tiendas')

@section('cabecera')
    @parent
    <x-cabecera subTitulo="Listado de Productos Tiendas">
        <i class="fa-solid fa-boxes-stacked"></i> Listado de Productos Tiendas
    </x-cabecera>
@endsection

@section('contenido')
    @if (session('mensaje'))
        <div class="card gradient-for-card-se mb-2">
            <div class="card-body text-center" style="background-color: #0e1321">
                <p class="card-text lead fs-4"> {{ session('mensaje') }} </p>
            </div>
        </div>
    @endif

    <x-listviewrelations
        :registros="$productoTiendas"
        modelo="productoTienda"
        :campos="[
            'id',
            'cantidad',
            'producto_id',
            'tienda_id',
            'nombretienda',
            'nombreproducto',
            'tienda.nombre',
            'tienda.ubicacion',
            'producto.nombre',
            'producto.precio'
        ]"
    />
@endsection

resources/views/productoTienda/show.blade.php
@extends('layouts.main')

@section('titulo', 'Mostrar')

@section('contenido')
<div class="row">
    <ul class="nav nav-tabs">
        <li class="nav-item">
            <a class="nav-link active disabled" aria-disabled="true">Producto Tienda {{ $productoTienda->id }}</a>
        </li>
    
        <li class="nav-item">
            <a class="nav-link" href="{{ route('productoTienda.edit', $productoTienda->id) }}">Editar Producto Tienda</a>
        </li>
        
        <li class="nav-item" style="margin-left: auto;">
            <a class="nav-link" aria-current="page" href="{{ route('productoTienda.index') }}">Volver</a>
        </li>
    </ul>

    @if (session('mensaje'))
        <div class="card gradient-for-card-se mt-4">
            <div class="card-body text-center" style="background-color: #0e1321">
                <p class="card-text lead fs-4"> {{ session('mensaje') }} </p>
            </div>
        </div>
    @endif
    
    <div class="col-lg-10 my-4 mb-sm-0 offset-lg-1">
        <div class="card text-center listadoTarjetaCliente">
            <div class="card-header">
                <span class="fs-3 text-center text-is-gradient">Producto Tienda {{ $productoTienda->id }}</span>
            </div>

            <div class="card-body text-center">
                <i class="fa-solid fa-shop-lock fa-5x profile-pic text-gradient-primary"></i>

                <div class="row mt-4">
                    <div class="col-lg-6">
                        <div class="list-group">
                            <div class="list-group-item d-flex justify-content-between align-items-center p-3">
                                <span class="fw-bold text-uppercase">ID Producto:</span>
                                <span class="ms-auto">{{ $productoTienda->producto_id }}</span>
                            </div>

                            <div class="list-group-item d-flex justify-content-between align-items-center p-3">
                                <span class="fw-bold text-uppercase">Cantidad:</span>
                                <span class="ms-auto">{{ $productoTienda->cantidad }}</span>
                            </div>

                            <div class="list-group-item d-flex justify-content-between align-items-center p-3">
                                <span class="fw-bold text-uppercase">Nombre Tienda:</span>
                                <span class="text-truncate ms-auto" style="max-width: 100%">{{ $productoTienda->tienda->nombre }}</span>
                            </div>
                        </div>
                    </div>
                    
                    <div class="col-lg-6">
                        <div class="list-group">
                            <div class="list-group-item d-flex justify-content-between align-items-center p-3">
                                <span class="fw-bold text-uppercase">ID Tienda:</span>
                                <span class="text-truncate ms-auto" style="max-width: 100%">{{ $productoTienda->tienda_id }}</span>
                            </div>

                            <div class="list-group-item d-flex justify-content-between align-items-center p-3">
                                <span class="fw-bold text-uppercase">Nombre Producto:</span>
                                <span class="text-truncate ms-auto" style="max-width: 100%">{{ $productoTienda->producto->nombre }}</span>
                            </div>
                            
                        </div>
                    </div>   
                </div>

                <div class="my-4 d-flex justify-content-center align-items-center">
                    <a class="btn btn-outline-success me-2" href="{{ route('productoTienda.edit', $productoTienda->id) }}" role="button">Editar</a>
                    
                    <form action="{{ route('productoTienda.destroy', $productoTienda)}}" method="POST">
                        @csrf @method('DELETE')
                        <button type="submit" class="btn btn-outline-danger">Borrar</button>
                    </form>      
                </div>
            </div>
        </div>
        <div class="gradient-for-card-tb"></div>
    </div>
</div>
@endsection